package com.ustadmobile.core.db.dao;

import java.lang.System;

@com.ustadmobile.door.annotation.Repository()
@androidx.room.Dao()
@kotlin.Metadata(mv = {1, 6, 0}, k = 1, d1 = {"\u0000.\n\u0002\u0018\u0002\n\u0002\u0018\u0002\n\u0002\u0018\u0002\n\u0002\b\u0002\n\u0002\u0018\u0002\n\u0002\u0010\b\n\u0002\u0018\u0002\n\u0000\n\u0002\u0010\t\n\u0002\b\u0003\n\u0002\u0010\u0002\n\u0002\b\u0007\b\'\u0018\u00002\b\u0012\u0004\u0012\u00020\u00020\u0001B\u0005\u00a2\u0006\u0002\u0010\u0003J,\u0010\u0004\u001a\u000e\u0012\u0004\u0012\u00020\u0006\u0012\u0004\u0012\u00020\u00070\u00052\u0006\u0010\b\u001a\u00020\t2\u0006\u0010\n\u001a\u00020\u00062\u0006\u0010\u000b\u001a\u00020\tH\'J\u0011\u0010\f\u001a\u00020\rH\u00a7@\u00f8\u0001\u0000\u00a2\u0006\u0002\u0010\u000eJ\u0011\u0010\u000f\u001a\u00020\rH\u00a7@\u00f8\u0001\u0000\u00a2\u0006\u0002\u0010\u000eJ\u001b\u0010\u0010\u001a\u00020\r2\b\b\u0001\u0010\u0011\u001a\u00020\tH\u00a7@\u00f8\u0001\u0000\u00a2\u0006\u0002\u0010\u0012J\u001b\u0010\u0013\u001a\u00020\r2\b\b\u0001\u0010\u0011\u001a\u00020\tH\u00a7@\u00f8\u0001\u0000\u00a2\u0006\u0002\u0010\u0012\u0082\u0002\u0004\n\u0002\b\u0019\u00a8\u0006\u0014"}, d2 = {"Lcom/ustadmobile/core/db/dao/MessageDao;", "Lcom/ustadmobile/core/db/dao/BaseDao;", "Lcom/ustadmobile/lib/db/entities/Message;", "()V", "findAllMessagesByChatUid", "Lcom/ustadmobile/door/DoorDataSourceFactory;", "", "Lcom/ustadmobile/lib/db/entities/MessageWithPerson;", "entityUid", "", "tableId", "loggedInPersonUid", "replicateOnChangeChat", "", "(Lkotlin/coroutines/Continuation;)Ljava/lang/Object;", "replicateOnChangePosts", "replicateOnNewNodeChats", "newNodeId", "(JLkotlin/coroutines/Continuation;)Ljava/lang/Object;", "replicateOnNewNodePosts", "lib-database"})
public abstract class MessageDao implements com.ustadmobile.core.db.dao.BaseDao<com.ustadmobile.lib.db.entities.Message> {
    
    public MessageDao() {
        super();
    }
    
    @org.jetbrains.annotations.Nullable()
    @com.ustadmobile.door.annotation.ReplicationRunOnNewNode()
    @androidx.room.Query(value = "\n     REPLACE INTO MessageReplicate(messagePk, messageDestination)\n      SELECT DISTINCT Message.messageUid AS messagePk,\n             :newNodeId AS messageDestination\n        FROM UserSession\n             JOIN Message ON\n                  ((    Message.messageTableId = 127\n                    AND Message.messageEntityUid IN\n                        (SELECT ChatMember.chatMemberChatUid \n                          FROM ChatMember\n                         WHERE ChatMember.chatMemberPersonUid = UserSession.usPersonUid))\n                  OR UserSession.usSessionType = 2)\n       WHERE UserSession.usClientNodeId = :newNodeId\n         AND UserSession.usStatus = 1\n         AND Message.messageLct != COALESCE(\n             (SELECT messageVersionId\n                FROM MessageReplicate\n               WHERE messagePk = Message.messageUid\n                 AND messageDestination = :newNodeId), 0) \n      /*psql ON CONFLICT(messagePk, messageDestination) DO UPDATE\n             SET messagePending = true\n      */       \n    ")
    @com.ustadmobile.door.annotation.ReplicationCheckPendingNotificationsFor(value = {com.ustadmobile.lib.db.entities.Message.class})
    public abstract java.lang.Object replicateOnNewNodeChats(@com.ustadmobile.door.annotation.NewNodeIdParam()
    long newNodeId, @org.jetbrains.annotations.NotNull()
    kotlin.coroutines.Continuation<? super kotlin.Unit> continuation);
    
    @org.jetbrains.annotations.Nullable()
    @com.ustadmobile.door.annotation.ReplicationRunOnNewNode()
    @androidx.room.Query(value = "\n     REPLACE INTO MessageReplicate(messagePk, messageDestination)\n      SELECT DISTINCT Message.messageUid AS messagePk,\n             :newNodeId AS messageDestination\n        FROM UserSession\n        \n             JOIN PersonGroupMember \n                  ON UserSession.usPersonUid = PersonGroupMember.groupMemberPersonUid\n             \n               JOIN ScopedGrant\n                    ON ScopedGrant.sgGroupUid = PersonGroupMember.groupMemberGroupUid\n                        AND (ScopedGrant.sgPermissions & \n        \n                  2 \n                  \n                       ) > 0\n               JOIN Clazz \n                    ON \n            ((ScopedGrant.sgTableId = -2\n                                AND ScopedGrant.sgEntityUid = -2)\n                            OR (ScopedGrant.sgTableId = 6\n                                AND ScopedGrant.sgEntityUid = Clazz.clazzUid)\n                            OR (ScopedGrant.sgTableId = 164\n                                AND ScopedGrant.sgEntityUid = Clazz.clazzSchoolUid))\n        \n        \n            \n             JOIN Message \n                  ON Message.messageTableId = 132\n                  AND Message.messageClazzUid = Clazz.clazzUid\n            \n            \n       WHERE UserSession.usClientNodeId = :newNodeId\n         AND UserSession.usStatus = 1\n         AND Message.messageLct != COALESCE(\n             (SELECT messageVersionId\n                FROM MessageReplicate\n               WHERE messagePk = Message.messageUid\n                 AND messageDestination = :newNodeId), 0) \n      /*psql ON CONFLICT(messagePk, messageDestination) DO UPDATE\n             SET messagePending = true\n      */       \n    ")
    @com.ustadmobile.door.annotation.ReplicationCheckPendingNotificationsFor(value = {com.ustadmobile.lib.db.entities.Message.class})
    public abstract java.lang.Object replicateOnNewNodePosts(@com.ustadmobile.door.annotation.NewNodeIdParam()
    long newNodeId, @org.jetbrains.annotations.NotNull()
    kotlin.coroutines.Continuation<? super kotlin.Unit> continuation);
    
    @org.jetbrains.annotations.Nullable()
    @androidx.room.Query(value = "\n         REPLACE INTO MessageReplicate(messagePk, messageDestination)\n          SELECT DISTINCT Message.messageUid AS messageUid,\n                 UserSession.usClientNodeId AS messageDestination\n            FROM ChangeLog\n                 JOIN Message\n                     ON ChangeLog.chTableId = 126\n                        AND ChangeLog.chEntityPk = Message.messageUid\n                        AND Message.messageTableId = 127\n                 JOIN UserSession ON\n                      ((UserSession.usPersonUid IN \n                           (SELECT ChatMember.chatMemberPersonUid\n                              FROM ChatMember\n                             WHERE ChatMember.chatMemberChatUid = Message.messageEntityUid))\n                       OR UserSession.usSessionType = 2)       \n           WHERE UserSession.usStatus = 1\n             AND UserSession.usClientNodeId != (\n                 SELECT nodeClientId \n                   FROM SyncNode\n                  LIMIT 1)\n             AND Message.messageLct != COALESCE(\n                 (SELECT messageVersionId\n                    FROM MessageReplicate\n                   WHERE messagePk = Message.messageUid\n                     AND messageDestination = UserSession.usClientNodeId), 0)\n         /*psql ON CONFLICT(messagePk, messageDestination) DO UPDATE\n             SET messagePending = true\n          */               \n    ")
    @com.ustadmobile.door.annotation.ReplicationCheckPendingNotificationsFor(value = {com.ustadmobile.lib.db.entities.Message.class})
    @com.ustadmobile.door.annotation.ReplicationRunOnChange(value = {com.ustadmobile.lib.db.entities.Message.class})
    public abstract java.lang.Object replicateOnChangeChat(@org.jetbrains.annotations.NotNull()
    kotlin.coroutines.Continuation<? super kotlin.Unit> continuation);
    
    @org.jetbrains.annotations.Nullable()
    @androidx.room.Query(value = "\n         REPLACE INTO MessageReplicate(messagePk, messageDestination)\n          SELECT DISTINCT Message.messageUid AS messageUid,\n                 UserSession.usClientNodeId AS messageDestination\n            FROM ChangeLog\n            \n                 JOIN Message\n                     ON ChangeLog.chTableId = 126\n                        AND ChangeLog.chEntityPk = Message.messageUid\n                        AND Message.messageTableId = 132\n                        \n                 JOIN Clazz\n                      ON Clazz.clazzUid = Message.messageClazzUid\n                 \n            JOIN ScopedGrant\n                 ON \n            ((ScopedGrant.sgTableId = -2\n                                AND ScopedGrant.sgEntityUid = -2)\n                            OR (ScopedGrant.sgTableId = 6\n                                AND ScopedGrant.sgEntityUid = Clazz.clazzUid)\n                            OR (ScopedGrant.sgTableId = 164\n                                AND ScopedGrant.sgEntityUid = Clazz.clazzSchoolUid))\n        \n                    AND (ScopedGrant.sgPermissions & \n        \n                  2\n                 \n              \n                                                       ) > 0\n             JOIN PersonGroupMember AS PrsGrpMbr\n                   ON ScopedGrant.sgGroupUid = PrsGrpMbr.groupMemberGroupUid\n                                               \n              JOIN UserSession\n                   ON UserSession.usPersonUid = PrsGrpMbr.groupMemberPersonUid\n                      AND UserSession.usStatus = 1\n            \n                       \n           WHERE UserSession.usStatus = 1\n             AND UserSession.usClientNodeId != (\n                 SELECT nodeClientId \n                   FROM SyncNode\n                  LIMIT 1)\n             AND Message.messageLct != COALESCE(\n                 (SELECT messageVersionId\n                    FROM MessageReplicate\n                   WHERE messagePk = Message.messageUid\n                     AND messageDestination = UserSession.usClientNodeId), 0)\n         /*psql ON CONFLICT(messagePk, messageDestination) DO UPDATE\n             SET messagePending = true\n          */               \n    ")
    @com.ustadmobile.door.annotation.ReplicationCheckPendingNotificationsFor(value = {com.ustadmobile.lib.db.entities.Message.class})
    @com.ustadmobile.door.annotation.ReplicationRunOnChange(value = {com.ustadmobile.lib.db.entities.Message.class})
    public abstract java.lang.Object replicateOnChangePosts(@org.jetbrains.annotations.NotNull()
    kotlin.coroutines.Continuation<? super kotlin.Unit> continuation);
    
    @org.jetbrains.annotations.NotNull()
    @androidx.room.Query(value = "\n       SELECT\n              Message.*,\n              Person.*,\n              MessageRead.*\n        FROM Message\n        LEFT JOIN Person\n          ON Message.messageSenderPersonUid = Person.personUid\n        LEFT JOIN MessageRead\n          ON MessageRead.messageReadMessageUid = Message.messageUid\n             AND MessageRead.messageReadPersonUid = :loggedInPersonUid\n       WHERE Message.messageTableId = :tableId\n              AND Message.messageEntityUid = :entityUid\n    ORDER BY Message.messageTimestamp DESC\n    ")
    public abstract com.ustadmobile.door.DoorDataSourceFactory<java.lang.Integer, com.ustadmobile.lib.db.entities.MessageWithPerson> findAllMessagesByChatUid(long entityUid, int tableId, long loggedInPersonUid);
}